#include <stdio.h>
#include <stdlib.h>


#include "draw.h"
#include "aquarium.h"
#include "over.h"

#include "matrix.h"

/*
  - Matrix scroller "plugin" for Sherman's aquarium -

  Yes, I know this is really out of the subject.
  But one afternoon I was bored and felt for doing 
  this and nothing else.
*/

#define LETTERS 28

/* Make it stupid. Never more than thosen rows. */

static int pauselist[10000];

static char *fallindata[10000];
static char charnum[10000];
static int bright_x[10];
static int bright_y[10];
static int bright_num;
static int xrows, yrows;
static int matrix_line_alloc;



static SA_Image matrix_dark, matrix_bright;




void make_matrix_line(int row, int start)
{
    int i,k,j;

    for(i=start;i<(start+20);i++){
	j=(rand() % 30)+1;
	if(j<LETTERS){
	    j=rand()%12+2;
	    for(k=i;((k<(i+j)) && (k<(start+20)));k++)
		fallindata[row][k]=rand()%(LETTERS-1) + 1;
	}
	else{
	    j=(rand()%5)+10;
	    for(k=i;((k<(i+j)) && (k<(20+start)));k++)
		fallindata[row][k]=0;
	} 
	i=k;
    }
}


void matrix_init(void)
{

    load_image("matrix1.png",
	       &matrix_dark,
	       LETTERS);

    load_image("matrix2.png",
	       &matrix_bright,
	       LETTERS);

}

void matrix_exit(void)
{
    if(matrix_line_alloc)
	matrix_end();

    if(matrix_dark.pixbuf!=NULL)
	g_object_unref(matrix_dark.pixbuf);
    if(matrix_bright.pixbuf!=NULL)
	g_object_unref(matrix_bright.pixbuf);


}

void matrix_start(void)
{
    int i;
    AquariumData *ad;
    bright_num=rand()%8;

    ad = aquarium_get_settings_ptr();

    xrows = ad->xmax/matrix_dark.width+2;
    yrows = ad->ymax/matrix_dark.height+2;

    if(xrows>1000) printf("This will crash for sure!\n");

    for(i=0;i<bright_num;i++){
	bright_x[i]=rand()%xrows;
	bright_y[i]=rand()%yrows;
    }

    matrix_line_alloc = 1;

    for(i=0;i<xrows;i++){
	pauselist[i]=0;
	fallindata[i] = g_malloc0(50);
	make_matrix_line(i,0);
	make_matrix_line(i,20);
	charnum[i]=rand()% 40;
    }


}


void matrix_end(void)
{
    int i;

    for(i=0;i<xrows;i++){
	if(fallindata[i]!=NULL){
	    g_free(fallindata[i]);
	    fallindata[i]=NULL;
	}
    }
    matrix_line_alloc = 0;
}




void matrix_update(void)	
{
    AquariumData *ad;
    int j,i,k,y,x=-4,c,a=0;
    int sum=0;

    ad = aquarium_get_settings_ptr();


    for(j=0;j<xrows;j++){

	y=0;

    
	if(charnum[j]<35) a=5;
	else a=40-charnum[j];
    
	for(k=charnum[j];k<(charnum[j]+a);k++)
	    sum+=(int)fallindata[j][k];
    
	if(sum==0 && pauselist[j]==-79){
	    if(rand()%5==4) pauselist[j]=10;
	} 
	else
	    pauselist[j]=-79;
     
	if(pauselist[j]<=0){
	    charnum[j]--;
	    if(charnum[j]==0) charnum[j]=40;
	}
	else
	    pauselist[j]--;

	c=charnum[j];

	/* Draw all falling signs in a row */

	for(;;){ /* */

	    over_draw(x,y,(int)fallindata[j][c],
		      matrix_dark.width,
		      matrix_dark.height,
		      matrix_dark.image);
      
	    if(c==10)
		make_matrix_line(j,20);
     
	    if(c==30)
		make_matrix_line(j,0);

	    if(c>=40) c=0;

	    c++;
	    y+=matrix_dark.height;
	    if(y>ad->ymax) break;
	}
	x+=matrix_dark.width;

    }
    for(i=0;i<bright_num;i++){
	over_draw(bright_x[i]*matrix_bright.width-4, 
		  bright_y[i]*matrix_bright.height,
		    (rand()%(LETTERS-1))+1, 
		  matrix_bright.width,
		  matrix_bright.height,
		  matrix_bright.image);
    }

}

