
#include <stdio.h>
#include <stdlib.h>

#include "aquarium.h"

#include "fish.h"
#include "bubble.h"
#include "date.h"
#include "clock.h"
#include "background.h"
#include "over.h"
#include "leds.h"
#include "bottom.h"
#include "xmms_sn.h"
#include "soundeffects.h"
#include "thermometer.h"

/* Over "plugins" */
#include "matrix.h"
#include "plasma.h"
#include "tetris.h"


#include "settings.h"



void bubble_save_settings(void)
{
    Bubble_settings *bubble_settings;

    bubble_settings = bubble_get_settings_ptr();

    gai_save_int("bubble/max_bubbles",bubble_settings->max_bubbles);

}

void thermometer_load_settings(void)
{
    Thermometer_settings *thermometer_settings;

    thermometer_settings = thermometer_get_settings_ptr();

    thermometer_settings->draw1 = gai_load_int_with_default("thermometer/draw1",DRAW_BEFORE);
    thermometer_settings->vert1 = gai_load_int_with_default("thermometer/vert1",BOTTOM);
    thermometer_settings->horz1 = gai_load_int_with_default("thermometer/horz1",RIGHT);
    thermometer_settings->split1 = gai_load_int_with_default("thermometer/split1",FALSE);
    thermometer_settings->r1 = (unsigned char )gai_load_int_with_default("thermometer/r1",0xe0);
    thermometer_settings->g1 = (unsigned char )gai_load_int_with_default("thermometer/g1",0x00);
    thermometer_settings->b1 = (unsigned char )gai_load_int_with_default("thermometer/b1",0x00);
    thermometer_settings->alpha1 = (unsigned char )gai_load_int_with_default("thermometer/alpha1",0xff);

    thermometer_settings->r1_s = (unsigned char )gai_load_int_with_default("thermometer/r1_s",0xe0);
    thermometer_settings->g1_s = (unsigned char )gai_load_int_with_default("thermometer/g1_s",0x00);
    thermometer_settings->b1_s = (unsigned char )gai_load_int_with_default("thermometer/b1_s",0x00);
    thermometer_settings->alpha1_s = (unsigned char )gai_load_int_with_default("thermometer/alpha1_s",0xff);
    thermometer_settings->messure1 = gai_load_int_with_default("thermometer/cpu1",STATUS_CPU);
    thermometer_settings->messure1_s = gai_load_int_with_default("thermometer/cpu1_s",STATUS_CPU);
    thermometer_settings->roof1 = gai_load_int_with_default("thermometer/roof1",33600/8);
    thermometer_settings->roof1_s = gai_load_int_with_default("thermometer/roof1_s",33600/8);
    thermometer_settings->mount_point1_s = gai_load_string_with_default("thermometer/mount_point1_s","/");
    thermometer_settings->mount_point1 = gai_load_string_with_default("thermometer/mount_point1","/");

    thermometer_settings->draw2 = gai_load_int_with_default("thermometer/draw2",DRAW_BEFORE);
    thermometer_settings->vert2 = gai_load_int_with_default("thermometer/vert2",BOTTOM);
    thermometer_settings->horz2 = gai_load_int_with_default("thermometer/horz2",RIGHT);
    thermometer_settings->split2 = gai_load_int_with_default("thermometer/split2",FALSE);
    thermometer_settings->r2 = (unsigned char )gai_load_int_with_default("thermometer/r2",0xe0);
    thermometer_settings->g2 = (unsigned char )gai_load_int_with_default("thermometer/g2",0x00);
    thermometer_settings->b2 = (unsigned char )gai_load_int_with_default("thermometer/b2",0x00);
    thermometer_settings->alpha2 = (unsigned char )gai_load_int_with_default("thermometer/alpha2",0xff);

    thermometer_settings->r2_s = (unsigned char )gai_load_int_with_default("thermometer/r2_s",0xe0);
    thermometer_settings->g2_s = (unsigned char )gai_load_int_with_default("thermometer/g2_s",0x00);
    thermometer_settings->b2_s = (unsigned char )gai_load_int_with_default("thermometer/b2_s",0x00);
    thermometer_settings->alpha2_s = (unsigned char )gai_load_int_with_default("thermometer/alpha2_s",0xff);
    thermometer_settings->messure2 = gai_load_int_with_default("thermometer/cpu2",STATUS_CPU);
    thermometer_settings->messure2_s = gai_load_int_with_default("thermometer/cpu2_s",STATUS_CPU);
    thermometer_settings->roof2 = gai_load_int_with_default("thermometer/roof2",33600/8);
    thermometer_settings->roof2_s = gai_load_int_with_default("thermometer/roof2_s",33600/8);
    thermometer_settings->mount_point2_s = gai_load_string_with_default("thermometer/mount_point2_s","/");
    thermometer_settings->mount_point2 = gai_load_string_with_default("thermometer/mount_point2","/");



}

void thermometer_save_settings(void)
{
    Thermometer_settings *thermometer_settings;

    thermometer_settings = thermometer_get_settings_ptr();

    gai_save_int("thermometer/draw1",thermometer_settings->draw1);
    gai_save_int("thermometer/vert1",thermometer_settings->vert1);
    gai_save_int("thermometer/horz1",thermometer_settings->horz1);
    gai_save_int("thermometer/split1",thermometer_settings->split1);
    gai_save_int("thermometer/r1",(unsigned int)thermometer_settings->r1);
    gai_save_int("thermometer/g1",(unsigned int)thermometer_settings->g1);
    gai_save_int("thermometer/b1",(unsigned int)thermometer_settings->b1);
    gai_save_int("thermometer/alpha1",(unsigned int)thermometer_settings->alpha1);

    gai_save_int("thermometer/r1_s",(unsigned int)thermometer_settings->r1_s);
    gai_save_int("thermometer/g1_s",(unsigned int)thermometer_settings->g1_s);
    gai_save_int("thermometer/b1_s",(unsigned int)thermometer_settings->b1_s);
    gai_save_int("thermometer/alpha1_s",(unsigned int)thermometer_settings->alpha1_s);
    gai_save_int("thermometer/cpu1",thermometer_settings->messure1);
    gai_save_int("thermometer/cpu1_s",thermometer_settings->messure1_s);
    gai_save_int("thermometer/roof1",thermometer_settings->roof1);
    gai_save_int("thermometer/roof1_s",thermometer_settings->roof1_s);
    gai_save_string("thermometer/mount_point1_s",thermometer_settings->mount_point1_s);
    gai_save_string("thermometer/mount_point1",thermometer_settings->mount_point1);


    gai_save_int("thermometer/draw2",thermometer_settings->draw2);
    gai_save_int("thermometer/vert2",thermometer_settings->vert2);
    gai_save_int("thermometer/horz2",thermometer_settings->horz2);
    gai_save_int("thermometer/split2",thermometer_settings->split2);
    gai_save_int("thermometer/r2",(unsigned int)thermometer_settings->r2);
    gai_save_int("thermometer/g2",(unsigned int)thermometer_settings->g2);
    gai_save_int("thermometer/b2",(unsigned int)thermometer_settings->b2);
    gai_save_int("thermometer/alpha2",(unsigned int)thermometer_settings->alpha2);

    gai_save_int("thermometer/r2_s",(unsigned int)thermometer_settings->r2_s);
    gai_save_int("thermometer/g2_s",(unsigned int)thermometer_settings->g2_s);
    gai_save_int("thermometer/b2_s",(unsigned int)thermometer_settings->b2_s);
    gai_save_int("thermometer/alpha2_s",(unsigned int)thermometer_settings->alpha2_s);
    gai_save_int("thermometer/cpu2",thermometer_settings->messure2);
    gai_save_int("thermometer/cpu2_s",thermometer_settings->messure2_s);
    gai_save_int("thermometer/roof2",thermometer_settings->roof2);
    gai_save_int("thermometer/roof2_s",thermometer_settings->roof2_s);
    gai_save_string("thermometer/mount_point2_s",thermometer_settings->mount_point2_s);
    gai_save_string("thermometer/mount_point2",thermometer_settings->mount_point2);



}



void bubble_load_settings(void)
{
    Bubble_settings *bubble_settings;

    bubble_settings = bubble_get_settings_ptr();

    bubble_settings->max_bubbles = gai_load_int_with_default("bubble/max_bubbles",5);

}


void date_load_settings(void)
{
    Date_settings *date_settings;

    date_settings = date_get_settings_ptr();
      
    date_settings->on = gai_load_bool_with_default("date/on",TRUE);

    date_settings->draw = gai_load_int_with_default("date/draw",DRAW_AFTER);


    date_settings->vert = gai_load_bool_with_default("date/vert",TOP);
    date_settings->horz = gai_load_bool_with_default("date/horz",RIGHT);

    date_settings->r = (unsigned char)gai_load_int_with_default("date/r",208);
    date_settings->g = (unsigned char)gai_load_int_with_default("date/g",208);
    date_settings->b = (unsigned char)gai_load_int_with_default("date/b",208);
    date_settings->alpha = (unsigned char)gai_load_int_with_default("date/alpha",80);

}

void date_save_settings(void)
{

    Date_settings *date_settings;

    date_settings = date_get_settings_ptr();

    
    gai_save_bool("date/on",date_settings->on);
    gai_save_bool("date/draw",date_settings->draw);

    gai_save_bool("date/horz",date_settings->horz);
    gai_save_bool("date/vert",date_settings->vert);

    gai_save_int("date/r",(unsigned int)date_settings->r);
    gai_save_int("date/g",(unsigned int)date_settings->g);
    gai_save_int("date/b",(unsigned int)date_settings->b);
    gai_save_int("date/alpha",(unsigned int)date_settings->alpha);

}


void clock_load_settings(void)
{
    Clock_settings *clock_settings;

    clock_settings = clock_get_settings_ptr();

    
    clock_settings->type = gai_load_int_with_default("clock/type", CLOCK_OFF);

    clock_settings->analog_seconds = gai_load_bool_with_default("clock/analog_seconds", TRUE);
    clock_settings->digital_seconds = gai_load_bool_with_default("clock/digital_seconds", TRUE);


    clock_settings->draw = gai_load_int_with_default("clock/draw", DRAW_BEFORE);

    clock_settings->vert = gai_load_int_with_default("clock/vert", CENTER);
    clock_settings->horz = gai_load_int_with_default("clock/horz", CENTER);


    /* Set up some mint green colour as default */

    clock_settings->digital_colour_r = (unsigned char)gai_load_int_with_default("clock/digital_colour_r", 4);
    clock_settings->digital_colour_g = (unsigned char)gai_load_int_with_default("clock/digital_colour_g", 226);
    clock_settings->digital_colour_b = (unsigned char)gai_load_int_with_default("clock/digital_colour_b", 145);
    clock_settings->digital_colour_alpha = (unsigned char)gai_load_int_with_default("clock/digital_colour_alpha", 80);

    clock_settings->digital_blinking = gai_load_bool_with_default("clock/digital_blinking", TRUE);

    clock_settings->digital_fontsize = gai_load_int_with_default("clock/digital_fontsize", CLOCK_SMALL_FONT);


    /* Some yellow colour */
    clock_settings->fuzzy_colour_r = (unsigned char)gai_load_int_with_default("clock/fuzzy_colour_r", 226);
    clock_settings->fuzzy_colour_g = (unsigned char)gai_load_int_with_default("clock/fuzzy_colour_g", 226);
    clock_settings->fuzzy_colour_b = (unsigned char)gai_load_int_with_default("clock/fuzzy_colour_b", 4);
    clock_settings->fuzzy_colour_alpha = (unsigned char)gai_load_int_with_default("clock/fuzzy_colour_alpha",80);

    /* Some red version */
    clock_settings->analog_colour_hour_r = (unsigned char)gai_load_int_with_default("clock/analog_colour_hour_r",226);
    clock_settings->analog_colour_hour_g = (unsigned char)gai_load_int_with_default("clock/analog_colour_hour_g",49);
    clock_settings->analog_colour_hour_b = (unsigned char)gai_load_int_with_default("clock/analog_colour_hour_b",4);
    clock_settings->analog_colour_hour_alpha = (unsigned char)gai_load_int_with_default("clock/analog_colour_hour_alpha",80);

    /* Green */
    clock_settings->analog_colour_min_r = (unsigned char)gai_load_int_with_default("clock/analog_colour_min_r",23);
    clock_settings->analog_colour_min_g = (unsigned char)gai_load_int_with_default("clock/analog_colour_min_g",226);
    clock_settings->analog_colour_min_b = (unsigned char)gai_load_int_with_default("clock/analog_colour_min_b",4);
    clock_settings->analog_colour_min_alpha = (unsigned char)gai_load_int_with_default("clock/analog_colour_min_alpha",80);
    /* Yellow */
    clock_settings->analog_colour_sec_r = (unsigned char)gai_load_int_with_default("clock/analog_colour_sec_r",255);
    clock_settings->analog_colour_sec_g = (unsigned char)gai_load_int_with_default("clock/analog_colour_sec_g",255);
    clock_settings->analog_colour_sec_b = (unsigned char)gai_load_int_with_default("clock/analog_colour_sec_b",0);
    clock_settings->analog_colour_sec_alpha = (unsigned char)gai_load_int_with_default("clock/analog_colour_sec_alpha",80);

    clock_settings->analog_keep_circular = gai_load_bool_with_default("clock/analog_keep_circular", TRUE);


}


void clock_save_settings(void)
{
    Clock_settings *clock_settings;

    clock_settings = clock_get_settings_ptr();

    gai_save_int("clock/type",clock_settings->type);

    gai_save_bool("clock/analog_seconds",clock_settings->analog_seconds);
    gai_save_bool("clock/digital_seconds",clock_settings->digital_seconds);

    gai_save_int("clock/draw",clock_settings->draw);

    gai_save_int("clock/horz",clock_settings->horz);

    gai_save_int("clock/vert",clock_settings->vert);

    gai_save_int("clock/digital_colour_r",(unsigned int)clock_settings->digital_colour_r);
    gai_save_int("clock/digital_colour_g",(unsigned int)clock_settings->digital_colour_g);
    gai_save_int("clock/digital_colour_b",(unsigned int)clock_settings->digital_colour_b);
    gai_save_int("clock/digital_colour_alpha",(unsigned int)clock_settings->digital_colour_alpha);

    gai_save_bool("clock/digital_blinking",clock_settings->digital_blinking);

    gai_save_int("clock/digital_fontsize",clock_settings->digital_fontsize);


    gai_save_int("clock/fuzzy_colour_r",(unsigned int)clock_settings->fuzzy_colour_r);
    gai_save_int("clock/fuzzy_colour_g",(unsigned int)clock_settings->fuzzy_colour_g);
    gai_save_int("clock/fuzzy_colour_b",(unsigned int)clock_settings->fuzzy_colour_b);
    gai_save_int("clock/fuzzy_colour_alpha",(unsigned int)clock_settings->fuzzy_colour_alpha);

    gai_save_int("clock/analog_colour_hour_r",(unsigned int)clock_settings->analog_colour_hour_r);
    gai_save_int("clock/analog_colour_hour_g",(unsigned int)clock_settings->analog_colour_hour_g);
    gai_save_int("clock/analog_colour_hour_b",(unsigned int)clock_settings->analog_colour_hour_b);
    gai_save_int("clock/analog_colour_hour_alpha",(unsigned int)clock_settings->analog_colour_hour_alpha);

    gai_save_int("clock/analog_colour_min_r",(unsigned int)clock_settings->analog_colour_min_r);
    gai_save_int("clock/analog_colour_min_g",(unsigned int)clock_settings->analog_colour_min_g);
    gai_save_int("clock/analog_colour_min_b",(unsigned int)clock_settings->analog_colour_min_b);
    gai_save_int("clock/analog_colour_min_alpha",(unsigned int)clock_settings->analog_colour_min_alpha);

    gai_save_int("clock/analog_colour_sec_r",(unsigned int)clock_settings->analog_colour_sec_r);
    gai_save_int("clock/analog_colour_sec_g",(unsigned int)clock_settings->analog_colour_sec_g);
    gai_save_int("clock/analog_colour_sec_b",(unsigned int)clock_settings->analog_colour_sec_b);
    gai_save_int("clock/analog_colour_sec_alpha",(unsigned int)clock_settings->analog_colour_sec_alpha);

    gai_save_bool("clock/analog_keep_circular",clock_settings->analog_keep_circular);


}


void background_load_settings(void)
{
    Background_settings *background_settings;

    background_settings = background_get_settings_ptr();


    background_settings->solid = gai_load_bool_with_default("background/solid", FALSE);
    background_settings->shaded = gai_load_bool_with_default("background/shaded", TRUE);
    background_settings->image = gai_load_bool_with_default("background/image", FALSE);
    background_settings->wateralike = gai_load_bool_with_default("background/wateralike", FALSE);

    background_settings->imagename = gai_load_string_with_default("background/imagename","");
    background_settings->imagename_new = NULL;

    background_settings->r1 = (unsigned char)gai_load_int_with_default("background/r1",12);
    background_settings->g1 = (unsigned char)gai_load_int_with_default("background/g1",100);
    background_settings->b1 = (unsigned char)gai_load_int_with_default("background/b1",220);

    background_settings->r2 = (unsigned char)gai_load_int_with_default("background/r2",12);
    background_settings->g2 = (unsigned char)gai_load_int_with_default("background/g2",100);
    background_settings->b2 = (unsigned char)gai_load_int_with_default("background/b2",220);

    background_settings->r3 = (unsigned char)gai_load_int_with_default("background/r3",5);
    background_settings->g3 = (unsigned char)gai_load_int_with_default("background/g3",40);
    background_settings->b3 = (unsigned char)gai_load_int_with_default("background/b3",80);



}


void background_save_settings(void)
{
    Background_settings *background_settings;

    background_settings = background_get_settings_ptr();

    /*
    if(background_settings->imagename!=NULL)
	g_free(background_settings->imagename);
    background_settings->imagename = g_strdup(background_settings->imagename_new);
    g_free(background_settings->imagename_new);
    background_settings->imagename_new = NULL;
    */

    gai_save_string("background/imagename",background_settings->imagename);

    gai_save_bool("background/solid",background_settings->solid);
    gai_save_bool("background/shaded",background_settings->shaded);
    gai_save_bool("background/image",background_settings->image);
    gai_save_bool("background/wateralike",background_settings->wateralike);

    gai_save_int("background/r1",(int)background_settings->r1);
    gai_save_int("background/g1",(int)background_settings->g1);
    gai_save_int("background/b1",(int)background_settings->b1);

    gai_save_int("background/r2",(int)background_settings->r2);
    gai_save_int("background/g2",(int)background_settings->g2);
    gai_save_int("background/b2",(int)background_settings->b2);

    gai_save_int("background/r3",(int)background_settings->r3);
    gai_save_int("background/g3",(int)background_settings->g3);
    gai_save_int("background/b3",(int)background_settings->b3);


}


void bottom_load_settings(void)
{
    Bottom_settings *bottom_settings;

    bottom_settings = bottom_get_settings_ptr();

    bottom_settings->have_sea_floor = gai_load_bool_with_default("bottom/have_sea_floor", TRUE);
    bottom_settings->max_plants = gai_load_int_with_default("bottom/max_plants",5);
    bottom_settings->num_bottom_animals = gai_load_int_with_default("bottom/num_bottom_animals",1);
    bottom_settings->scale = gai_load_int_with_default("bottom/scale",30);
    bottom_settings->random_plants = gai_load_bool_with_default("bottom/random_plants", TRUE);

}

void bottom_save_settings(void)
{

    Bottom_settings *bottom_settings;

    bottom_settings = bottom_get_settings_ptr();

    gai_save_bool("bottom/have_sea_floor",bottom_settings->have_sea_floor);
    gai_save_bool("bottom/random_plants",bottom_settings->random_plants);
    gai_save_int("bottom/max_plants",bottom_settings->max_plants);
    gai_save_int("bottom/scale",bottom_settings->scale);
    gai_save_int("bottom/num_bottom_animals",bottom_settings->num_bottom_animals);


}




void fish_load_settings(void)
{
    int numfish = 0;

    Fish_settings *fish_settings;

    fish_settings = fish_get_settings_ptr();
    
    fish_settings->eat = gai_load_bool_with_default("fish/eat", TRUE);
    fish_settings->explode = gai_load_bool_with_default("fish/explode", TRUE);

    fish_settings->scale = gai_load_int_with_default("fish/scale",DEFAULT_SCALE);


    fish_settings->speed = gai_load_int_with_default("fish/speed",DEFAULT_SPEED);

    fish_settings->scale_diff = gai_load_bool_with_default("fish/scale_diff", TRUE);
    fish_settings->rebirth = gai_load_bool_with_default("fish/rebirth", FALSE);

    fish_settings->swordfish_agr = gai_load_int_with_default("fish/swordfish_agr",75);
    fish_settings->hunter_agr = gai_load_int_with_default("fish/hunter_agr",75);


    fish_settings->num_fish = gai_load_int_with_default("fish/num_fish",NRFISH);
    fish_settings->random_fish = gai_load_bool_with_default("fish/random_fish", TRUE);
    fish_settings->selection_fish = gai_load_bool_with_default("fish/selection_fish", FALSE);
    fish_settings->random_pop_fish = gai_load_bool_with_default("fish/random_pop_fish", FALSE);


    numfish += fish_settings->fish1 = gai_load_int_with_default("fish/fish1",1);
    numfish += fish_settings->fish2 = gai_load_int_with_default("fish/fish2",1);
    numfish += fish_settings->fish3 = gai_load_int_with_default("fish/fish3",1);
    numfish += fish_settings->fish4 = gai_load_int_with_default("fish/fish4",1);
    numfish += fish_settings->fish5 = gai_load_int_with_default("fish/fish5",1);
    numfish += fish_settings->fish6 = gai_load_int_with_default("fish/fish6",1);
    numfish += fish_settings->swordfish = gai_load_int_with_default("fish/swordfish",1);
    numfish += fish_settings->blowfish = gai_load_int_with_default("fish/blowfish",1);
    numfish += fish_settings->fillmore = gai_load_int_with_default("fish/fillmore",1);
    numfish += fish_settings->sherman = gai_load_int_with_default("fish/sherman",1);
    numfish += fish_settings->prey = gai_load_int_with_default("fish/prey",1);
    numfish += fish_settings->hunter = gai_load_int_with_default("fish/hunter",1);
    numfish += fish_settings->lori = gai_load_int_with_default("fish/lori",1);
    numfish += fish_settings->ernest = gai_load_int_with_default("fish/ernest",1);
    numfish += fish_settings->squid = gai_load_int_with_default("fish/squid",1);
    numfish += fish_settings->megan = gai_load_int_with_default("fish/megan",1);
    numfish += fish_settings->bdweller = gai_load_int_with_default("fish/bdweller",1);
    numfish += fish_settings->hawthorne = gai_load_int_with_default("fish/hawthorne",1);

    if(fish_settings->selection_fish){
	//printf("numfish: %d\n",numfish);
	fish_settings->num_fish = numfish;
    }

    if(fish_settings->random_pop_fish)
	fish_settings->num_fish = random() % 20;


}




void fish_save_settings(void)
{
    Fish_settings *fish_settings;

    fish_settings = fish_get_settings_ptr();

    //printf("fish save settings\n");
  
    gai_save_bool("fish/eat",fish_settings->eat);
    gai_save_bool("fish/explode",fish_settings->explode);
    gai_save_int("fish/scale",fish_settings->scale);
    
    gai_save_int("fish/swordfish_agr",fish_settings->swordfish_agr);
    gai_save_int("fish/hunter_agr",fish_settings->hunter_agr);


    gai_save_bool("fish/scale_diff",fish_settings->scale_diff);
    gai_save_bool("fish/random_fish",fish_settings->random_fish);
    gai_save_bool("fish/selection_fish", fish_settings->selection_fish);
    gai_save_bool("fish/random_pop_fish",fish_settings->random_pop_fish);
    gai_save_bool("fish/rebirth",fish_settings->rebirth);

    //printf("fish save settings 2\n");


    if(fish_settings->selection_fish)
	fish_settings->num_fish = fish_settings->fish1 + fish_settings->fish2 + fish_settings->fish3 + 
	    fish_settings->fish4 + fish_settings->fish5 + fish_settings->fish6 + fish_settings->swordfish +
	    fish_settings->blowfish + fish_settings->fillmore + fish_settings->sherman + fish_settings->prey +
	    fish_settings->hunter + fish_settings->lori + fish_settings->ernest + fish_settings->squid + 
	    fish_settings->megan;

    //printf("fish save settings 3\n");

    gai_save_int("fish/fish1",fish_settings->fish1);
    gai_save_int("fish/fish2",fish_settings->fish2);
    gai_save_int("fish/fish3",fish_settings->fish3);
    gai_save_int("fish/fish4",fish_settings->fish4);
    gai_save_int("fish/fish5",fish_settings->fish5);
    gai_save_int("fish/fish6",fish_settings->fish6);
    gai_save_int("fish/swordfish",fish_settings->swordfish);
    gai_save_int("fish/blowfish",fish_settings->blowfish);
    gai_save_int("fish/fillmore",fish_settings->fillmore);
    gai_save_int("fish/sherman",fish_settings->sherman);
    gai_save_int("fish/prey",fish_settings->prey);
    gai_save_int("fish/hunter",fish_settings->hunter);
    gai_save_int("fish/lori",fish_settings->lori);
    gai_save_int("fish/ernest",fish_settings->ernest);
    gai_save_int("fish/squid",fish_settings->squid);
    gai_save_int("fish/megan",fish_settings->megan);
    gai_save_int("fish/bdweller",fish_settings->bdweller);
    gai_save_int("fish/hawthorne",fish_settings->hawthorne);


    //printf("fish save settings 4\n");

    gai_save_int("fish/num_fish",fish_settings->num_fish);

    //printf("fish save settings: done\n");


}


void over_load_settings(void)
{
    Over_settings *over_settings;

    over_settings = over_get_settings_ptr();


    over_settings->off = gai_load_bool_with_default("over/off", FALSE);
    over_settings->matrix = gai_load_bool_with_default("over/matrix", TRUE);
    over_settings->plasma = gai_load_bool_with_default("over/plasma", FALSE);
    over_settings->tetris = gai_load_bool_with_default("over/tetris", FALSE);

    over_settings->fade = gai_load_bool_with_default("over/fade", TRUE);
    over_settings->cursor_off = gai_load_bool_with_default("over/cursor_off", TRUE);

}


void over_save_settings(void)
{
    Over_settings *over_settings;

    over_settings = over_get_settings_ptr();

    gai_save_bool("over/off",over_settings->off);
    gai_save_bool("over/matrix",over_settings->matrix);
    gai_save_bool("over/plasma",over_settings->plasma);
    gai_save_int("over/tetris",over_settings->tetris);

    gai_save_bool("over/fade",over_settings->fade);
    gai_save_bool("over/cursor_off",over_settings->cursor_off);

}

void tetris_load_highscores(void)
{
    int i;
    char tmp[100];

    Tetris_highscore_table *t;
    t = tetris_get_highscore_table_ptr();

    for(i=0;i<10;i++){
	g_snprintf(tmp,100,"tetris/highscore%d_score",i);
	t[i].score = gai_load_int_with_default(tmp,10-i);

	g_snprintf(tmp,100,"tetris/highscore%d_level",i);
	t[i].level = gai_load_int_with_default(tmp,1);

	g_snprintf(tmp,100,"tetris/highscore%d_lines",i);
	t[i].lines = gai_load_int_with_default(tmp,10-i);
    }


}

void tetris_save_highscores(void)
{
    char tmp[100];
    int i;
    Tetris_highscore_table *t;
    t = tetris_get_highscore_table_ptr();

    for(i=0;i<10;i++){
	g_snprintf(tmp,100,"tetris/highscore%d_score",i);
	gai_save_int(tmp,t[i].score);
	g_snprintf(tmp,100,"tetris/highscore%d_level",i);
	gai_save_int(tmp,t[i].level);
	g_snprintf(tmp,100,"tetris/highscore%d_lines",i);
	gai_save_int(tmp,t[i].lines);
    }

}

void leds_load_settings(void)
{
    Leds_settings *leds_settings;

    leds_settings = leds_get_settings_ptr();

    
    leds_settings->draw = gai_load_int_with_default("leds/draw",DRAW_AFTER);

    leds_settings->horz = gai_load_int_with_default("leds/horz",LEDS_LEFT);
    leds_settings->vert = gai_load_int_with_default("leds/vert",LEDS_TOP);


    leds_settings->vert_horz = gai_load_bool_with_default("leds/vert_horz", TRUE);


    leds_settings->led1_func = gai_load_int_with_default("leds/led1_func", LEDS_NUMLOCK);
    leds_settings->led2_func = gai_load_int_with_default("leds/led2_func", LEDS_SCROLLOCK);
    leds_settings->led3_func = gai_load_int_with_default("leds/led3_func", LEDS_CAPSLOCK);
    leds_settings->led4_func = gai_load_int_with_default("leds/led4_func", LEDS_OFF);

    leds_settings->led1_colour = gai_load_int_with_default("leds/led1_colour", LEDS_VIOLET);
    leds_settings->led2_colour = gai_load_int_with_default("leds/led2_colour", LEDS_VIOLET);
    leds_settings->led3_colour = gai_load_int_with_default("leds/led3_colour", LEDS_VIOLET);
    leds_settings->led4_colour = gai_load_int_with_default("leds/led4_colour", LEDS_VIOLET);


}



void leds_save_settings(void)
{
    Leds_settings *leds_settings;

    leds_settings = leds_get_settings_ptr();

    gai_save_int("leds/draw",leds_settings->draw);

    gai_save_int("leds/vert",leds_settings->vert);
    gai_save_int("leds/horz",leds_settings->horz);

    gai_save_int("leds/vert_horz",leds_settings->vert_horz);


    gai_save_int("leds/led1_func",leds_settings->led1_func);
    gai_save_int("leds/led2_func",leds_settings->led2_func);
    gai_save_int("leds/led3_func",leds_settings->led3_func);
    gai_save_int("leds/led4_func",leds_settings->led4_func);


    gai_save_int("leds/led1_colour",leds_settings->led1_colour);
    gai_save_int("leds/led2_colour",leds_settings->led2_colour);
    gai_save_int("leds/led3_colour",leds_settings->led3_colour);
    gai_save_int("leds/led4_colour",leds_settings->led4_colour);


}

void xmms_sn_load_settings(void)
{
    Xmms_sn_settings *xmms_sn_settings;

    xmms_sn_settings = xmms_sn_get_settings_ptr();


    xmms_sn_settings->on = gai_load_bool_with_default("xmms_sn/on", FALSE);

    xmms_sn_settings->r = gai_load_int_with_default("xmms_sn/r",45);
    xmms_sn_settings->g = gai_load_int_with_default("xmms_sn/g",145);
    xmms_sn_settings->b = gai_load_int_with_default("xmms_sn/b",245);

    xmms_sn_settings->draw = gai_load_int_with_default("xmms_sn/draw",DRAW_AFTER);

    xmms_sn_settings->direction = gai_load_int_with_default("xmms_sn/direction",XMMS_SN_HORIZONTAL);
    xmms_sn_settings->alpha = gai_load_int_with_default("xmms_sn/alpha",128);
    xmms_sn_settings->speed = gai_load_int_with_default("xmms_sn/speed",200);


    xmms_sn_settings->horz = gai_load_int_with_default("xmms_sn/horz",CENTER);
    xmms_sn_settings->vert = gai_load_int_with_default("xmms_sn/vert",LEFT);

    xmms_sn_settings->fb = gai_load_int_with_default("xmms_sn/fb",XMMS_SN_FORWARDS);

}

void xmms_sn_save_settings(void)
{
    Xmms_sn_settings *xmms_sn_settings;

    xmms_sn_settings = xmms_sn_get_settings_ptr();


    gai_save_bool("xmms_sn/on",xmms_sn_settings->on);

    gai_save_int("xmms_sn/r",xmms_sn_settings->r);
    gai_save_int("xmms_sn/g",xmms_sn_settings->g);
    gai_save_int("xmms_sn/b",xmms_sn_settings->b);


    gai_save_int("xmms_sn/draw",xmms_sn_settings->draw);
    gai_save_int("xmms_sn/direction",xmms_sn_settings->direction);
    gai_save_int("xmms_sn/alpha",xmms_sn_settings->alpha);
    gai_save_int("xmms_sn/speed",xmms_sn_settings->speed);

    gai_save_int("xmms_sn/horz",xmms_sn_settings->horz);
    gai_save_int("xmms_sn/vert",xmms_sn_settings->vert);
    gai_save_int("xmms_sn/fb",xmms_sn_settings->fb);


    
}


void sound_load_settings(void)
{
    Sound_settings *sound_settings;

    sound_settings = sound_get_settings_ptr();

    sound_settings->on = gai_load_bool_with_default("sound/on", FALSE);

    sound_settings->type_mp3 = gai_load_bool_with_default("sound/type_mp3", TRUE);
    sound_settings->type_ogg = gai_load_bool_with_default("sound/type_ogg", FALSE);

    sound_settings->prg = gai_load_string_with_default("sound/prg","mpg123 -q");

}

void sound_save_settings(void)
{
    Sound_settings *sound_settings;

    sound_settings = sound_get_settings_ptr();

    gai_save_bool("sound/on",sound_settings->on);
    gai_save_bool("sound/type_mp3",sound_settings->type_mp3);
    gai_save_bool("sound/type_ogg",sound_settings->type_ogg);

    gai_save_string("sound/prg",sound_settings->prg);

}

void general_load_settings(void)
{
    General_settings *general_settings;	
    general_settings = general_get_settings_ptr();
    general_settings->ratio_width = gai_load_int_with_default("general/ratio_width",1);
    general_settings->ratio_height = gai_load_int_with_default("general/ratio_height",1);
}

void general_save_settings(void)
{
    General_settings *general_settings;	
    general_settings = general_get_settings_ptr();

    //printf("%d %d\n", general_settings->ratio_width, general_settings->ratio_height);

    gai_save_int("general/ratio_width",general_settings->ratio_width);
    gai_save_int("general/ratio_height",general_settings->ratio_height);

}
